/*
pFlow Control v1.07
Created:  	Dec. 29, 2008	
Last Updated:  Mar. 23, 2010
Author :  John Rand (littl3fish@gmail.com) 
Version:  max 9 32&64bit, 2008 32&64bit, 2009 32&64Bit, 2010 32&64

What it does:
pFlow Control rollout turn the checkboxed pf source node emission on and off as well as selecting the treeview item selects the pf source.
Set Particle Flow display types for all or selected display nodes.
Set the Viewport Display color for all or selected Particle Flow display nodes in a scene.
Set the Viewport Quantity Multiplier for all or selected PF sources
Set the Particle System Limit for all or selected sources
Set the Integration Steps for Viewport and Render time

Install: put it where ever you want. just un it and it will make a copy in the user UI->Macroscripts folder.

Upon first running the script it will create the file pFlowControl.ini the Dialog will be located at 0,0 with a height of 0, just move it and expandit as you wish

pFlow Control can be found under the catergory "JRandom" and add a shortcut to open.

***********************************************************************************************
MODIFY THIS AT YOUR OWN RISK
*/
--start
macroScript pFlowControl category:"JRandom"

(
	--global
	global pFlowControl

	struct pFlowControlStruct
	(
		fl_pFlowControl, floaterPositionX,floaterPositionY, floaterSizeX,floaterSizeY, 
		pFlowEmission_rollout, rlt_pFlowEmission, rlt_pFlowEmissionState, tvHeight, rolloutScrollPos,
		dispColor_rollout, rlt_dispColor,
		dispType_rollout, rlt_dispType,
		vptPartCount_rollout, rlt_vptPartCount, pflowVPTPerc_arr, thePflowSel_arr, theVptIntStep, theRndrIntStep,
		
		fn dialogControl =
		(
			pFlowControl.floaterPositionX = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Position" "Position X" as integer
			pFlowControl.floaterPositionY = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Position" "Position Y" as integer
			pFlowControl.floaterSizeX = 178
			pFlowControl.floaterSizeY = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Size" "Size Y" as integer
			pFlowControl.rolloutScrollPos = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowEmission Rollout" "Scroll Position" as integer
			--rlt_pFlowEmission = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowEmission Rollout" "Rolled State" as integer
			
		),
		
		fn pFlowControlUI =
		(
			--rollouts	
			rollout pFlowEmission_rollout "pFlow Control v1.0" 
			(
				-- local variables
				local pfSourceNodes = #()
				--functions
				fn initTreeView tv_pFlowControl =
				( 
					tv_pFlowControl.Indent = 14
					tv_pFlowControl.CheckBoxes = true
				)
				
				fn addChildren theNode theChildren =
				(
					for c in theChildren do
					(
						newNode = theNode.Nodes.add c.name
						newNode.tag = dotNetMXSValue c
						newNode.checked = not c.enable_particles == false
						--newNode.forecolor = (dotNetClass "System.Drawing.Color").fromARGB c.wirecolor.r c.wirecolor.g c.wirecolor.b
						addChildren newNode c.children
					)
				)
				
				fn fillInTreeView tv_pFlowControl =
				(
					theRoot = tv_pFlowControl.Nodes.add "PFlow Systems"
					pfSourceNodes = for o in objects where classOf o == PF_Source collect o-- or classOf o == ParticleGroup 
					addChildren theRoot pfSourceNodes 
				)
				
				--rollout definition
				button btn_refresh "Refresh All" width:136 height:16 pos:[4,5]
				button btn_particleView "PV" width:18 height:16 pos:[144,5]
				dotNetControl tv_pFlowControl "TreeView" width:150 height:260 align:#center
				--handlers
				on tv_pFlowControl Click arg do 
				(
					hitNode = tv_pFlowControl.GetNodeAt (dotNetObject "System.Drawing.Point" arg.x arg.y)
					if hitNode != undefined do 
					try(select hitNode.tag.value)catch(max select none) 
				) 
				
				on tv_pFlowControl AfterCheck arg do try (arg.node.tag.value.Enable_Particles = arg.node.checked)catch()
				
				on btn_refresh pressed do
				(
					pfSourceNodes = #()
					tv_pFlowControl.nodes.clear()
					initTreeView tv_pFlowControl 
					fillInTreeView tv_pFlowControl
					tv_pFlowControl.ExpandAll()
					tv_pFlowControl.height =  if pfSourceNodes.count <= 10 then (if pfSourceNodes.count <= 0 then 80 else ((pfSourceNodes.count*16)+22)) else (pFlowControl.tvHeight = 180)
					pFlowEmission_rollout.height = if pfSourceNodes.count <= 10 then (if pfSourceNodes.count <= 0 then 110 else ((pfSourceNodes.count*16)+54)) else (pFlowControl.tvHeight = 180)+35
					--populate other rollout functions
					--Display Color Rollout
					pFlowControl.dispColor_rollout.dumpPfDisplayOpColor()
					pFlowControl.dispColor_rollout.pfDisplayOpColorList()
					pFlowControl.dispColor_rollout.mlb_pfDispOpColor.items = pFlowControl.dispColor_rollout.pfDisplayOpColorNames
					--Display type Rollout
					pFlowControl.dispType_rollout.dumpPfDisplayOpType()
					pFlowControl.dispType_rollout.pfDisplayOpTypeList()
					pFlowControl.dispType_rollout.mlb_pfDispOpType.items = pFlowControl.dispType_rollout.pfDisplayOpTypeNames
					--Viewport Particle Count Rollout
					pFlowControl.vptPartCount_rollout.pflowVPTPerc_arr = #()
					pFlowControl.vptPartCount_rollout.thePflowSel_arr = #()
					pFlowControl.vptPartCount_rollout.pflowVPTPerc()
					
				)
				
				on btn_particleView pressed do
					(
						actionMan.executeAction 135018554 "32771"
					)
				
				on pFlowEmission_rollout open do 
				(
					initTreeView tv_pFlowControl 
					fillInTreeView tv_pFlowControl
					tv_pFlowControl.ExpandAll()
					pFlowControl.tvHeight = if pfSourceNodes.count <= 10 then (if pfSourceNodes.count <= 0 then 80 else ((pfSourceNodes.count*16)+22)) else (pFlowControl.tvHeight = 180)
					tv_pFlowControl.height = if pfSourceNodes.count <= 10 then (if pfSourceNodes.count <= 0 then 80 else ((pfSourceNodes.count*16)+22)) else (pFlowControl.tvHeight = 180)
					pFlowEmission_rollout.height = if pfSourceNodes.count <= 10 then (if pfSourceNodes.count <= 0 then 110 else ((pfSourceNodes.count*16)+54)) else (pFlowControl.tvHeight = 180)+35
					pFlowEmission_rollout.scrollPos = pFlowControl.rolloutScrollPos
				)
				
				on pFlowEmission_rollout close do 
				(
					pFlowControl.floaterPositionX = pFlowControl.fl_pFlowControl.pos.X as string
					setINISetting (getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Position" "Position X" pFlowControl.floaterPositionX
					pFlowControl.floaterPositionY = pFlowControl.fl_pFlowControl.pos.Y as string
					setINISetting (getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Position" "Position Y" pFlowControl.floaterPositionY
					pFlowControl.floaterSizeX = 176 as string
					setINISetting (getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Size" "Size X" pFlowControl.floaterSizeX
					pFlowControl.floaterSizeY = pFlowControl.fl_pFlowControl.size.Y as string
					setINISetting (getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowControl Floater Size" "Size Y" pFlowControl.floaterSizeY
					pFlowControl.rolloutScrollPos = pFlowControl.pFlowEmission_rollout.ScrollPos as string
					setINISetting (getdir #maxroot + "\\plugcfg\pFlowControl.ini") "PflowEmission Rollout" "Scroll Position" pFlowControl.rolloutScrollPos
					pfSourceNodes = undefined
					dgc = dotnetclass "system.gc"
					dgc.collect()
					pFlowControl = undefined
					gc()
				)
				/*
				on pFlowEmission_rollout rolledUp state do
				(
					--pFlowControl.rlt_pFlowEmission = state
					if state then setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowEmission Rollout" "Rolled State" "true"
					else setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "pFlowEmission Rollout" "Rolled State" "false"
				)
				*/
			)--end pFlowEmission Rollout
			
			rollout dispColor_rollout "Pflow Display Colors"
			(
				--local variables
				local pfDisplayOpColorNodes = #()
				local pfDisplayOpColorNames = #()
				--functions
				fn Obj_filt obj = classOf obj DisplayParticles 
				fn pfDisplayOpColorList =
				(
					pfDisplayOpColorNodes = for o in objects where classOf o == DisplayParticles collect o
					pfDisplayOpColorNames = for n in pfDisplayOpColorNodes collect n.name 
				)

				fn dumpPfDisplayOpColor =
				(
					pfDisplayOpColorNodes = undefined
					pfDisplayOpColorNames = undefined
					CurrentColorItems = undefined
				)
				--rollout definition
				MultiListBox mlb_pfDispOpColor  pos:[7,10] width:80 across:2 
				colorpicker clr_pfDispOpColor pos:[95,17] color:[255,210,100] width: 50 modal:true
				button btn_doSetSel "Set Selected" pos:[90,45] width:66 height:17
				button btn_doSetAll "Set All" pos:[90,64] width:40 height:17
				button btn_doRand "All Random" pos:[90,83] width:60 height:17
				button btn_doAdd "Add" pos:[90,108] height:17
				button btn_doRem "Remove Sel" pos:[90,126] height:17
				--handlers
				on clr_pfDispOpColor changed new_pfDispOpColor do 
				(
					for i in mlb_pfDispOpColor.selection do 
					(
						pfDisplayOpColorNodes[i].color = new_pfDispOpColor--.color--new_pfSRCcolor
					)
				)
				
				on btn_doSetSel pressed do
				(
					for i in mlb_pfDispOpColor.selection do 
					(
						pfDisplayOpColorNodes[i].color = clr_pfDispOpColor.color
					)
				)
				
				on btn_doSetAll pressed do
				(
					for i = 1 to pfDisplayOpColorNodes.count do 
					(
						pfDisplayOpColorNodes[i].color = clr_pfDispOpColor.color
					)
				)
				
				on btn_doRand pressed do
				(
					for i = 1 to pfDisplayOpColorNodes.count do 
					(	
						clr_rnd1 = random 0 255
						clr_rnd2 = random 0 255
						clr_rnd3 = random 0 255
						clr_rnd = color clr_rnd1 clr_rnd2 clr_rnd3
						--print clr_rnd
						pfDisplayOpColorNodes[i].color = clr_rnd
					)
				)
				
				on btn_doAdd pressed do
				(
					if mlb_pfDispOpColor.items.count <= 0 do
					(
						pfDisplayOpColorList()
						mlb_pfDispOpColor.items = pfDisplayOpColorNames
					)
					if mlb_pfDispOpColor.items.count >= 0 do
					(
						dumpPfDisplayOpColor ()
						pfDisplayOpColorList()
						mlb_pfDispOpColor.items = pfDisplayOpColorNames
					)
				)
				
				on btn_doRem pressed do
				( 
					currentColorItems = (mlb_pfDispOpColor.items as array)
					for o = (mlb_pfDispOpColor.items as array).count to 1 by -1 where ( findItem (mlb_pfDispOpColor.selection as array) o ) != 0 do deleteItem currentColorItems o
					mlb_pfDispOpColor.items = currentColorItems
					pfDisplayOpColorNodes = for n in currentColorItems where isValidNode (obj = getNodeByName n) collect obj
				)
				
				on dispColor_rollout open do
				(
					rlt_dispColor = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispColor Rollout" "Rolled State" as string
					if rlt_dispColor == "true" then dispColor_rollout.open = true else dispColor_rollout.open = false
					pfDisplayOpColorList()
					mlb_pfDispOpColor.items = pfDisplayOpColorNames
				)
				
				on dispColor_rollout rolledUp state do
				(
					if state then setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispColor Rollout" "Rolled State" "true"
					else setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispColor Rollout" "Rolled State" "false" 
				)
				
			)-- end Color Display Rollout
			
			rollout dispType_rollout "Pflow Display Type"
			(
				--local variables
				local pfDisplayOpTypeNodes = #()
				local pfDisplayOpTypeNames = #()
				local currentTypeItems  = #()
				--functions
				fn pfDisplayOpTypeList =
				(
					pfDisplayOpTypeNodes = for o in objects where classOf o == DisplayParticles collect o
					pfDisplayOpTypeNames = for n in pfDisplayOpTypeNodes collect n.name 
				)

				fn dumpPfDisplayOpType =
				(
					pfDisplayOpTypeNodes = undefined
					pfDisplayOpTypeNames = undefined
					currentColorItems = undefined
				)
				--rollout definition
				MultiListBox mlb_pfDispOpType pos:[7,14] width:80 across:2 
				dropdownlist ddl_pfDispOpType width:67 height:12 pos:[90,14] selection:3 items:#("None","Dots","Ticks","Circles","Lines","Bounding","Geometry","Diamonds","Boxes","Asterisks","Triangles") 
				button btn_doSetSelType "Set Selected" pos:[90,45] width:66 height:17
				button btn_doSetAllType "Set All" pos:[90,65] width:40 height:17
				button btn_doAddType "Add" pos:[90,110] height:17
				button btn_doRemType "Remove Sel" pos:[90,132] height:17
				--handlers
				on btn_doSetSelType pressed do
				(  
					for i in mlb_pfDispOpType.selection do 
					(
						
						pfDisplayOpTypeNodes[i].Type = (ddl_pfDispOpType.selection - 1)
					)
				)
				
				on btn_doSetAllType pressed do
				(  
					for i = 1 to pfDisplayOpTypeNodes.count do 
					(
						pfDisplayOpTypeNodes[i].Type = (ddl_pfDispOpType.selection - 1)
					)
				)
				
				on btn_doAddType pressed do
				(
					if mlb_pfDispOpType.items.count <= 0 do
					(
						pfDisplayOpTypeList()
						mlb_pfDispOpType.items = pfDisplayOpTypeNames
					)
					if mlb_pfDispOpType.items.count >= 0 do
					(
						dumpPfDisplayOpType ()
						pfDisplayOpTypeList()
						mlb_pfDispOpType.items = pfDisplayOpTypeNames
					)
				)
				
				on btn_doRemType pressed do
				( 
					currentTypeItems = (mlb_pfDispOpType.items as array)
					for o = (mlb_pfDispOpType.items as array).count to 1 by -1 where ( findItem (mlb_pfDispOpType.selection as array) o ) != 0 do deleteItem currentTypeItems o
					mlb_pfDispOpType.items = currentTypeItems
					pfDisplayOpTypeNodes = for n in currentTypeItems where isValidNode (obj = getNodeByName n) collect obj
				)
				
				on dispType_rollout open do
				(
					rlt_dispType = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispType Rollout" "Rolled State" as string
					if rlt_dispType == "true" then dispType_rollout.open = true else dispType_rollout.open = false
					pfDisplayOpTypeList()
					mlb_pfDispOpType.items = pfDisplayOpTypeNames
				)
				
				on dispType_rollout rolledUp state do
				(
					if state then setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispType Rollout" "Rolled State" "true"
					else setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "DispType Rollout" "Rolled State" "false" 
				)
				
			)-- end Display Type Rollout
			
			rollout vptPartCount_rollout "System Management"
			(
				--local variables
				local pflowVPTPerc_arr = #()
				local thePflowSel_arr = #()
				local theVptVal
				local theULmtVal
				--functions
				fn pflowVPTPerc =
				(
					pflowVPTPerc_arr = for o in objects where classOf o == PF_Source collect o
				)
				
				fn setPflowVPTPerc	= --Viewport Quantity Multiplier function
				(	
					pflowVPTPerc ()
					if vptPartCount_rollout.chk_selPflowOnly.checked == true then
					(
						if $ != undefined then
						(
							if classof $ != objectSet do
							(	
								if classof $ == PF_source then
								(
									thePflowSel = $
									thePflowSel.Quantity_Viewport = theVptVal
								)
							)
							if classof $ == objectSet do
							(
								thePflowSel_arr = $ as array
								for a = 1 to thePflowSel_arr.count do
								(
									thePflowSel_arr[a].Quantity_Viewport = theVptVal
								)
							)
						)
					)
					else
					(
						for p = 1 to pflowVPTPerc_arr.count do
						(
							pflowVPTPerc_arr[p].Quantity_Viewport = theVptVal
						)	
					)
				)
				
				fn setPflowSysUpperLimit	= --Particle flow system Management Particle Count Upper Limit Function
				(	
					pflowVPTPerc ()
					if vptPartCount_rollout.chk_selPflowOnly.checked == true then
					(
						if $ != undefined then
						(
							if classof $ != objectSet do
							(	
								if classof $ == PF_source then
								(
									thePflowSel = $
									thePflowSel.Particle_Amount_Limit = theULmtVal
								)
							)
							if classof $ == objectSet do
							(
								thePflowSel_arr = $ as array
								for a = 1 to thePflowSel_arr.count do
								(
									thePflowSel_arr[a].Particle_Amount_Limit  = theULmtVal
								)
							)
						)
					)
					else
					(
						for p = 1 to pflowVPTPerc_arr.count do
						(
							pflowVPTPerc_arr[p].Particle_Amount_Limit  = theULmtVal
						)	
					)
				)
				
				fn setPflowIntStepViewport	= --Set Viewport Integration Step
				(	
					pflowVPTPerc ()
					if vptPartCount_rollout.chk_selPflowOnly.checked == true then
					(
						if $ != undefined then
						(
							if classof $ != objectSet do
							(	
								if classof $ == PF_source then
								(
									thePflowSel = $
									thePflowSel.Integration_for_Viewport = pFlowControl.vptPartCount_rollout.theVptIntStep
								)
							)
							if classof $ == objectSet do
							(
								thePflowSel_arr = $ as array
								for a = 1 to thePflowSel_arr.count do
								(
									thePflowSel_arr[a].Integration_for_Viewport = pFlowControl.vptPartCount_rollout.theVptIntStep
								)
							)
						)
					)
					else
					(
						for p = 1 to pflowVPTPerc_arr.count do
						(
							pflowVPTPerc_arr[p].Integration_for_Viewport = pFlowControl.theVptIntStep
						)	
					)
				)
				
				fn setPflowIntStepRender	= --Set Render Integration Step
				(	
					pflowVPTPerc ()
					if vptPartCount_rollout.chk_selPflowOnly.checked == true then
					(
						if $ != undefined then
						(
							if classof $ != objectSet do
							(	
								if classof $ == PF_source then
								(
									thePflowSel = $
									thePflowSel.Integration_for_Render = pFlowControl.vptPartCount_rollout.theRndrIntStep
								)
							)
							if classof $ == objectSet do
							(
								thePflowSel_arr = $ as array
								for a = 1 to thePflowSel_arr.count do
								(
									thePflowSel_arr[a].Integration_for_Render = pFlowControl.vptPartCount_rollout.theRndrIntStep
								)
							)
						)
					)
					else
					(
						for p = 1 to pflowVPTPerc_arr.count do
						(
							pflowVPTPerc_arr[p].Integration_for_Render = pFlowControl.theRndrIntStep
						)	
					)
				)
				--rollout definition
				checkbox chk_selPflowOnly "Selected Pflow(s) Only" pos:[10,5]
				group "Viewport Qty. Multiplier"
				(
					spinner spn_vptPartCnt "Viewport Qty. %" pos:[10,43] range:[0.001,9999,1] fieldwidth:44 type:#float
					button btn_perc001 ".001" width:30 height:15 pos:[28,64]
					button btn_perc01 ".01" width:30 height:15 pos:[66,64]
					button btn_percpoint1 ".1" width:30 height:15 pos:[102,64]
					button btn_perc1 "1" width:30 height:15 pos:[10,81]
					button btn_perc10 "10" width:30 height:15 pos:[48,81]
					button btn_perc50 "50" width:30 height:15 pos:[86,81]
					button btn_perc100 "100" width:30 height:15 pos:[124,81]
				)
				group "Particle System Limit" 
				(
					spinner spn_PrtUpprLmt "Upper Limit:" pos:[10,130] range:[10000,100000000,10000000] fieldwidth:74 type:#integer
					button btn_SetPartLimit "Set Particle Limit" width:90 height:18 align:#center--pos:[124,56]
				)
				group "Intergration Step" 
				(
				label lbl_viewport "Viewport:" pos:[24,205]
				dropdownlist ddl_pfIntStepVpt  width:80 height:12 pos:[74,200] selection:1 items:#("Frame","Half Frame","1/4 Frame","1/8 Frame") 
				label lbl_render "Render:" pos:[34,230]
				dropdownlist ddl_pfIntStepRndr  width:80 height:12 pos:[74,225] selection:2 items:#("Frame","Half Frame","1/4 Frame","1/8 Frame","8 Ticks"," 4 Ticks","2 Ticks","1 Tick") 
				)
				--handlers
				on ddl_pfIntStepVpt selected theSel do
				(  
					pFlowControl.theVptIntStep = theSel-1
					setPflowIntStepViewport()
				)
				
				on ddl_pfIntStepRndr selected theSel do
				(  
					pFlowControl.theRndrIntStep = theSel-1
					setPflowIntStepRender()
				)
				
				on spn_VPTPartCnt changed val do
				(	
					theVptVal = spn_VPTPartCnt.value
					SetPflowVPTPerc()
				)
				
				on btn_perc001 pressed do
				(	
					theVptVal = 0.001
					SetPflowVPTPerc()
				)
				
				on btn_perc01 pressed do
				(	
					theVptVal = 0.01
					SetPflowVPTPerc()
				)
				
				on btn_percpoint1 pressed do
				(	
					theVptVal = 0.1
					SetPflowVPTPerc()
				)
				
				on btn_perc1 pressed do
				(	
					theVptVal = 1
					SetPflowVPTPerc()
				)
				
				on btn_perc10 pressed do
				(	
					theVptVal = 10
					SetPflowVPTPerc()
				)
				
				on btn_perc50 pressed do
				(	
					theVptVal = 50
					SetPflowVPTPerc()
				)
				
				on btn_perc100 pressed do
				(	
					theVptVal = 100
					SetPflowVPTPerc()
				)
				
				on btn_SetPartLimit pressed do
				(	
					theULmtVal = spn_PrtUpprLmt.value
					SetPflowSysUpperLimit()
				)
				
				on vptPartCount_rollout open do
				(
					rlt_vptPartCount = getINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "Viewport Percentage Rollout" "Rolled State" as string
					if rlt_vptPartCount  == "true" then vptPartCount_rollout.open = true else vptPartCount_rollout.open = false
				)
				
				on vptPartCount_rollout rolledUp state do
				(
					if state then setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "Viewport Percentage Rollout" "Rolled State" "true"
					else setINISetting(getdir #maxroot + "\\plugcfg\pFlowControl.ini") "Viewport Percentage Rollout" "Rolled State" "false" 
				)
			)--end Viewport Particle Count Rollout
			
			fl_pFlowControl = newRolloutFloater "pFlow Control v1.0" pFlowControl.floaterSizeX pFlowControl.floaterSizeY pFlowControl.floaterPositionX pFlowControl.floaterPositionY
			
			addrollout pFlowEmission_rollout fl_pFlowControl rolledup:false
			addrollout dispColor_rollout fl_pFlowControl
			addrollout dispType_rollout fl_pFlowControl
			addrollout vptPartCount_rollout fl_pFlowControl
			
		)--end pFlowControlUI function
	)--endStruct

	try(closeRolloutFloater pFlowControl.fl_pFlowControl)catch()	
	pFlowControl = pFlowControlStruct()
	pFlowControl.dialogControl()
	pFlowControl.pFlowControlUI()
	
	pFlowControl.pFlowEmission_rollout.scrollPos = pFlowControl.rolloutScrollPos

)--end macroscript

 
